const Generator = require('yeoman-generator');

module.exports = class extends Generator {
  prompting() {
    const prompts = [
      {
        type: 'list',
        name: 'templateType',
        message: '请选择需要的模板',
        choices: ['react纯state目录', 'reactDialog模板jsx']
      },
      {
        type: 'input',
        name: 'folderName',
        message: '请输入文件夹/文件名称，建议驼峰',
        validate: input => {
          if (!input || input.replace(' ', '') === '') {
            this.log('文件夹名称不能为空')
            return false;
          }

          return true;
        }
      }
    ];

    return this.prompt(prompts).then(props => {
      // To access props later use this.props.someAnswer;
      this.props = props;
    });
  }

  writing() {
    console.log(this.props.templateType);
    if (this.props.templateType === 'react纯state目录') {
      this.fs.copy(
        this.templatePath('stateFolder'),
        this.destinationPath(this.props.folderName)
      );
    }

    if (this.props.templateType === 'reactDialog模板jsx') {
      this.fs.copy(
        this.templatePath('dialog.jsx'),
        this.destinationPath(`${this.props.folderName}.jsx`)
      );
    }
  }
};
